//#pragma GCC optimize ( "0")

/*
 * cgiScripts.c
 *
 *  Created on: 8 nov. 2010
 *      Author: d.kleppe
 *      changes:
 *      V1.5	klp MAGNETIC_STATUS added to pollDataItem table
 */

/**
 * \addtogroup Webapps
 * @{
 */

/**
 * \defgroup cgiconfig cgiscripts
 * @{
 *
 */

/**
 * \file
 * functions for cgi-configuration
 */

#include <stdio.h>
#include <string.h>

#include "lwip/mem.h"
#include "cgiScripts.h"
#include "httpd-fs.h"

#include "thermometerTask.h"

//#include "stats.h"

extern float temperature[];

extern bool resetSystemReq;
extern uint32_t runTimeSecCounter;
extern uint32_t boardRevisionID;

const tCGI *g_pCGIs;
int g_iNumCGIs;

#define NUM_CGIurls 2

char* startCGIscript(int iIndex, char *pcParam[]);
char* readCGIvalues(int iIndex, char *pcParam[]);

int readTemperatureScript(char *pBuffer, int count);
int readTemperatureBufferScript(char *pBuffer, int count);

static int scriptState; //, scriptItem;

//extern const tCGI *g_pCGIs;
extern int g_iNumCGIs;
extern uint16_t fieldsParsed;

extern uint32_t boardRevisionID;
extern float boardTemperature;
CGIresponseFileHandler_t readResponseFile;

extern int maxRespTime;
extern int respTime;

static const tCGI CGIurls[NUM_CGIurls] = {
		{ "/Temperature",(tCGIHandler_t) readCGIvalues,	(CGIresponseFileHandler_t) readTemperatureScript },
		{ "/Buffer0",(tCGIHandler_t) readCGIvalues,	(CGIresponseFileHandler_t) readTemperatureBufferScript }
};

//{ "/cgi-bin/ixscript", (tCGIHandler_t) readCGIvalues, (CGIresponseFileHandler_t) sendmaxValuesRead },
//{ "/cgi-bin/axscript", (tCGIHandler_t) startCGIscript, (CGIresponseFileHandler_t) axScript },
//{ "/cgi-bin/debugscript", (tCGIHandler_t) readCGIvalues, (CGIresponseFileHandler_t) readDebugscript },
//{ "/cgi-bin/sxscript", (tCGIHandler_t) savescript, (CGIresponseFileHandler_t) saveRespscript },
//{ "/cgi-bin/srscript", (tCGIHandler_t) saveResetscript, (CGIresponseFileHandler_t) saveRespscript },
//{ "/cgi-bin/txscript", (tCGIHandler_t) txScript, (CGIresponseFileHandler_t) sendmaxValuesRead },
//{ "/cgi-bin/vxscript", (tCGIHandler_t) readSWVscript, (CGIresponseFileHandler_t) vxScript }};

/**
 * resets scriptstate and
 * sets readResponseFile to function belonging to script
 * @param[in] iIndex not used
 * @param[in] pcParam not used
 * @param[out] pointer to responsefilename, this file is used to supply variable data to client
 */

char * startCGIscript(int iIndex, char *pcParam[]) {
	scriptState = 0;
	readResponseFile = CGIurls[iIndex].responseFileHandler;
	return ("/CGIreturn.txt");
}

/**
 * parses CGI values
 * @param[in] iIndex not used
 * @param[in] pcParam pointer to string containing string with values
 * @param[out] pointer to responsefilename, this file is used to supply variable data to client
 */

char * readCGIvalues(int iIndex, char *pcParam[]) {
//	parseCGIstr((const char *) pcParam);
	return startCGIscript(iIndex, pcParam);
}

/**
 * saves parameters (config) into dataflash
 * after receiving parameters
 * @param[in] iIndex not used
 * @param[in] pcParam not used
 * @param[out] pointer to responsefilename, this file is used to supply variable data to client
 */

/* response after receiving SW version
 *
 *
 */

int vxScript(char *pBuffer, int count) {
	int nrChars = 0;
	switch (scriptState) {
	case 0:
		scriptState++;
		nrChars = sprintf(pBuffer, "READ=1\r\n");
		break;

	}
	return nrChars;
}

int readTemperatureScript(char *pBuffer, int count) {
	char * pntr = pBuffer;
	int nrChars = 0;
	switch (scriptState) {
	case 0:
		scriptState++;
		nrChars = sprintf(pntr, "%2.2f", temperature[0]);
		temperature[0]++;
		break;
	}
	return nrChars;
}

int readTemperatureBufferScript(char *pBuffer, int count) {
	char * pntr = pBuffer;
//	int maxValues = count / 5; // values: 201, 202 etc for 20.1 , 20.2 degrees
	int maxValues = count / 2; // 2 bytes per value
	static int valuesToSend;
	static int tempBufRdIndex;
	int nrCharsSend = 0;

	switch (scriptState) {
	case 0:
		valuesToSend = NR_BUFFERVALUES;
		tempBufRdIndex = tempBufWrtIndex;
		printf("temperatureBuf %d \n",tempBufWrtIndex);
		scriptState++;
	case 1:
		if (valuesToSend > 0) {
			if (tempBufRdIndex >= NR_BUFFERVALUES)
				tempBufRdIndex = 0;

			if ((maxValues + tempBufRdIndex) > NR_BUFFERVALUES)
				maxValues = NR_BUFFERVALUES - tempBufRdIndex; // last part of oldest data
			if ( maxValues > valuesToSend)
				maxValues = valuesToSend;

			for (int n = 0; n < maxValues; n++) {

				printf(" %d ",tempBuffer[0][tempBufRdIndex]);

				*pntr++ =  tempBuffer[0][tempBufRdIndex]; // LSB
				*pntr++ =  tempBuffer[0][tempBufRdIndex++] >> 8 ; // MSB
				nrCharsSend += 2;

			}
			valuesToSend -= maxValues;
		}
	    break;

	}
	return nrCharsSend;
}


void CGI_init(void) {
	g_pCGIs = CGIurls;
	g_iNumCGIs = NUM_CGIurls;
}

/** @} */
/** @} */

