/*
 * Thermometer.c
 *
 *  Created on: Sep 16, 2017
 *      Author: dig
 */
#include "freertos/FreeRTOS.h"
#include "freertos/portmacro.h"
#include "freertos/event_groups.h"

#include "driver/adc.h"
#include "driver/gpio.h"

#include "ntc.h"
#include "thermometerTask.h"

int tempBuffer[NR_NTCS][NR_BUFFERVALUES];
int tempBufWrtIndex;

// ADC2 unusable with wifi enabled
// GPIO 33 = ADC1-5  NTC
// GPIO 32 = ADC1-4 3V3/2



void thermometerTask(void *pvParameter) {
	
	portTickType xLastWakeTime;
//	const portTickType xPeriod = ( 50 / portTICK_RATE_MS );  // x200 averaging = 10 sec per new measurement
	
	int read_raw;
	int bufCntr = 20;
	
	float temp;
	adc1_config_channel_atten(ADC1_CHANNEL_5, ADC_ATTEN_11db); // 3.9 V
	adc1_config_channel_atten(ADC1_CHANNEL_4, ADC_ATTEN_11db); // 3.9 V
	adc1_config_width(ADC_WIDTH_12Bit);

	for ( int n = n ; n < NR_BUFFERVALUES; n++){
		tempBuffer[0][n] = 20*10;    //9999;
	}

	printf("tctask start \n");

//	xLastWakeTime = xTaskGetTickCount();

	while (1) {
	//	vTaskDelayUntil( &xLastWakeTime, xPeriod );
		vTaskDelay(50 / portTICK_RATE_MS);

		read_raw = adc1_get_voltage(ADC1_CHANNEL_4);
		NTCreferenceValue = 2 * read_raw;
		read_raw = adc1_get_voltage(ADC1_CHANNEL_5); // 1/2 reference
		temp = updateNTC( 0, read_raw);
		bufCntr--;
		if (bufCntr ==0) {
			bufCntr = 20;
			if ((temp > 900) || (temp < 0))
					temp = 999.9;
			tempBuffer[0][tempBufWrtIndex++] = (int) (temp * 10.0) ;

			if (tempBufWrtIndex == NR_BUFFERVALUES)
				tempBufWrtIndex = 0;
		}
		
//		r = ( int) calcNTC( read_raw);  // adcVal;
	//	printf("channel 5: %d  %2.2f \n", read_raw, temp);
		
	};
}

